// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include <debriefing.h>
#include <stage.h>

#include "stdio.h"	// for sprintf()

#include "input.h"
#include "vbl.h"

#define HL_Y 2	///< Y coordinate of debriefing headline

debriefing::debriefing(int bg, const spritedata* border, const backdropdata* backdrop, char* headline, int score, bool showsecrets, int secrets, int minutes, int seconds)
: widget(bg, border, 0, 22, 16, 32, 16, 1, true)
{
	char buf[40];

	ham_SetBgMode(0);

	setbackgroundimage(backdrop);

	drawstring(11-strlen(headline)/2, HL_Y, headline);

	drawstring(2, HL_Y+4, "Time");

	sprintf(buf, "%2d:%02d", minutes, seconds);
	drawstring(15, HL_Y+4,buf);

	// Draw score. FIXME: step>1 may show incorrect score, VBL_FRAMESKIP ignored
	drawstring(2, HL_Y+6, "Score");

	int step=1;
	if(score>50) step=10;
	if(score>500) step=100;
	if(score>5000) step=1000;
	if(score>50000)	step=10000;

	int s=0;
	settextdelay(0);
	while(s<=score)
	{
		sprintf(buf, "%4d",s);
		drawstring(16, HL_Y+6, buf);
		s+=step;
		VBL_NEXT_FRAME;
	}

	if(showsecrets)
	{
		// Draw secrets
		settextdelay(1);
		drawstring(2, HL_Y+8, "Secrets");

		s=0;
		settextdelay(0);
		while(s<=secrets)
		{
			sprintf(buf, "%4d", s);
			drawstring(16, HL_Y+8, buf);
			s++;
			VBL_NEXT_FRAME;
		}
	}

	// wait for action button press
	while(input::action());
	while(!input::action());
	while(input::action());

	delete this;
}

