// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

/// GBA hardware specifics

extern "C" {
#include <mygba.h>
}

/// Hardware abstraction class. This class provides static methods for initializing hardware and accessing hardware features.
class hw
{
public:
	static void init();		///< Perform hardware-dependant initializations

	/// Initialize a 1100 ticks per frame timer to be used for runtime profiling.
	static void initproftimer() { M_TIM2CNT_SPEED_SELECT_SET(2); } 	// 15.256 usec timer, one frame ~ 1100 ticks

	/// Reset the profiling timer.
	static void resetproftimer() { M_TIM2COUNT_SET(0); }

	/// Start the profiling timer.
	static void startproftimer() { M_TIM2CNT_TIMER_START; }

	/// Stop the profiling timer.
	static void stopproftimer() { M_TIM2CNT_TIMER_STOP; }

	/// Get the current value of the profiling timer.
	/// \returns Current profiling time in units of 1/1100 frame.
	static u16 getproftimer() { return F_TIM2COUNT_GET_CURRENT_VALUE; }
};

