// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#ifndef _CAMERA_H
#define _CAMERA_H

#include <guard.h>

/// A security camera. Same as a guard, except that it can be rotated arbitrarily, does not react to pushes and does not
/// collide nor block sight by default.
class camera : public guard
{
public:
	/// Camera constructor.
	camera(stage* parent, const spritedata* gfx, int xpos, int ypos);

	/// Implements the camera's vision in addition to the standard scriptable functionality.
	void compute(bool lowtime);

	/// Unlike its base class a camera will not notice when someone bumps into it.
	void push(sprite* pusher);

	/// Does not make sense for a camera.
	void attract(int x, int y, int speed_num, int speed_denom) {}
};

#endif
