// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#ifndef _DEBRIEFING_H
#define _DEBRIEFING_H

#include <widget.h>

/// A debriefing screen. Use this to show the final score, the total time and, optionally, the number of secrets discovered upon
/// completion of a stage. The headline is displayed centered on top of the widget.
/// This is a self-deleting modal dialog terminated by pressing the action button. In addition to the resources consumed by a widget
/// object this class allocates another HW background plus the number of BG tiles specified in bgtiles_size. It also uses alphablending and
/// takes up the entire BG palette.
class debriefing : public widget
{
public:
	/// The debriefing constructor
	/// \param bg The first of the two HW backgrounds used by debriefing.
	/// \param border The border graphics, or NULL for no border.
	/// \param backdrop An backdrop to be placed behind the widget, or NULL for none.
	/// \param headline The headline displayed at the top of the widget.
	/// \param score The score to be displayed.
	/// \param showsecrets Show the "secrets" entry?
	/// \param secrets The number of secrets discovered.
	/// \param minutes Time to be shown, minutes.
	/// \param seconds Time to be shown, seconds.
	debriefing(int bg, const spritedata* border, const backdropdata* backdrop, char* headline, int score, bool showsecrets, int secrets, int minutes, int seconds);
};

#endif
