// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#ifndef _MENU_H
#define _MENU_H

#include <widget.h>

/// A selection menu. This widget allocates a hefty three borders, the number of tiles you specify in bgtiles_size plus the standard
/// widget tiles. Use the getselection() method to construct a menu and get the user's choice. FIXME: Static layout limits use.
class menu : public widget
{
public:
	/// Creates a menu with the given options and returns the selection made by the user.
	/// \param bg First of three HW backgrounds used.
	/// \param border The border of the menu widget and the selection marker. FIXME: Make these independent.
	/// \param backdrop A backdrop to be placed behind the menu, or NULL for none.
	/// \param headline Headline of the menu.
	/// \param items List of menu options.
	/// \param numitems Number of menu options.
	/// \returns Number of selected option.
	static int getselection(int bg, const spritedata* border, const backdropdata* backdrop, const char* headline, const char** items, int numitems);

private:
	/// Menu constructor.
	menu(int bg, const spritedata* border, const backdropdata* backdrop, const char* headline, const char** items, int numitems);
	/// The menu destructor.
	~menu();
};

#endif
