// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include <item.h>
#include <misc.h>

item::item(level* parent, const spritedata* gfx, int xpos, int ypos)
: sprite(parent, gfx, xpos, ypos)
{
	// ASSERT item size
	setdescription("An item.");
	m_parent=parent;
	enablespritecollision(true);
	setradarcolor(S_RADAR_ITEM);
	m_autopick=m_pickable=true;
}

item::~item()
{
	m_parent->removefromallinventories(this);
}

void item::action(sprite* actor)
{
	if(m_pickable) m_parent->addtoinventory(this, actor);
}

void item::pickup(int x, int y)
{
	m_visible=false;		// invisible for collision detection etc., but still visible on the screen!
	setframeofreferencetoscreen(true);
	setpriority(P_ONTOP);	// brings the item to the front
	setpos(x, y);
}
void item::drop(int x, int y)
{
	m_visible=true;
	setframeofreferencetoscreen(false);
	setpriority(getcollidemapno());	// restores old sprite prio
	enablespritecollision(false);
	setpos(x, y);
}

void item::push(sprite* pusher)
{
	if(m_autopick)
	{
		m_parent->addtoinventory(this, pusher);
	}
	else
		sprite::push(pusher);
}
