// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include <widget.h>

#include "level1.h"

const char* level1::description="level1";

#include "level1_data.c"

extern const palettedata sprite_palette;
#include "level1_lvl_gfx.h"

extern const spritedata frame_sprite;
extern const fontdata console_font;
extern const palettedata msgbox_palette;

level1::level1(int first_bg)
: level(first_bg, &level1_map)
{
	setdefaultcollidemap(1);

	setexcess(2,2,12,0);
	setscrollbordery(60);
	setscrollborderx(110);
	setspritepalette(&sprite_palette);

#include "level1_lvl_ctor.h"

	setradar(0,SCREEN_WIDTH-64, SCREEN_HEIGHT-40, 64, 40);
	
	//scrolllock();
	
	widget::setcharacters(&console_font);
	widget::setpalette(&msgbox_palette);

	enableradar(true);

	addcamhint(16*16,2*16,25*16,11*16,11*16,1*16);	// for cam[0] (top right)
	addcamhint(2*16,6*16,10*16,15*16,1*16,7*16);	// for cam[2] (bottom left)
}

level1::~level1()
{
}

void level1::compute(bool lowtime)
{
	if(getscore()>0) faris->allowcrossfinishline(true);
	level::compute(lowtime);
}

level::state level1::endofstage()
{
	if(faris->hascrossedfinishline()) return c_won;
	return level::endofstage();
}

bool level1::playerusesitem(levelplayer* who, item* what, sprite* onwhat)
{
	return false;
}
