// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#ifndef _LEVEL1_H
#define _LEVEL1_H

#include <level.h>
#include <camera.h>
#include <levelplayer.h>
#include <item.h>
#include <explosive.h>
#include <swag.h>
#include <door.h>

/// The level1 stage.
class level1 : public level
{
public:
	/// The level1 constructor
	/// \param first_bg First of two HW backgrounds used by this stage.
	level1(int first_bg);
	virtual ~level1();		///< Mansion destructor.
	void compute(bool lowtime);

	virtual bool playerusesitem(levelplayer* who, item* what, sprite* onwhat);
	virtual level::state endofstage();
	
	static const char* description;

private:
#include "level1_lvl_decl.h"

};

#endif
