// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include <widget.h>

#include "level2.h"

const char* level2::description="level2";

#include "level2_data.c"

extern const palettedata sprite_palette;
#include "level2_lvl_gfx.h"

extern const spritedata frame_sprite;
extern const fontdata console_font;
extern const palettedata msgbox_palette;

level2::level2(int first_bg)
: level(first_bg, &level2_map)
{
	setdefaultcollidemap(1);

	setexcess(0,0,2,0);
	setscrollbordery(60);
	setscrollborderx(110);
	setspritepalette(&sprite_palette);

#include "level2_lvl_ctor.h"

	nick->setadjust(40);

	faris->setbounding(sprite::b_left,1);	// left edge of bounding box
	faris->setbounding(sprite::b_right,1);	// right edge of bounding box

	//faris->setsightable(false);
	//faris->setaudible(false);

	setradar(0,SCREEN_WIDTH-44, SCREEN_HEIGHT-68, 40, 64);
	
	//scrolllock();
	
	widget::setcharacters(&console_font);
	widget::setpalette(&msgbox_palette);

	enableradar(true);
}

level2::~level2()
{
}

void level2::compute(bool lowtime)
{
	level::compute(lowtime);
}

level::state level2::endofstage()
{
	if(nick->getypos()>=32*16)
	{
		// 100 points for the statue
		if(getscore()<100)	// endofstage() will be called more than once...
			modifyscore(100);
		faris->allowcrossfinishline(true);
	}
	if(faris->hascrossedfinishline()) return c_won;
	return level::endofstage();
}

bool level2::playerusesitem(levelplayer* who, item* what, sprite* onwhat)
{
	return false;
}
