// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include <widget.h>

#include "level3.h"

const char* level3::description="level3";

#include "level3_data.c"

extern const palettedata sprite_palette;
#include "level3_lvl_gfx.h"

extern const spritedata frame_sprite;
extern const fontdata console_font;
extern const palettedata msgbox_palette;

level3::level3(int first_bg)
: level(first_bg, &level3_map)
{
	setdefaultcollidemap(1);

	setexcess(0,2,2,0);
	setscrollbordery(60);
	setscrollborderx(110);
	setspritepalette(&sprite_palette);

#include "level3_lvl_ctor.h"

	setradar(0,SCREEN_WIDTH-64, SCREEN_HEIGHT-40, 64, 40);
	
	//scrolllock();
	
	widget::setcharacters(&console_font);
	widget::setpalette(&msgbox_palette);

	enableradar(true);
}

level3::~level3()
{
}

void level3::compute(bool lowtime)
{
	if(getscore()>0) faris->allowcrossfinishline(true);
	level::compute(lowtime);
}

level::state level3::endofstage()
{
	if(faris->hascrossedfinishline()) return c_won;
	return level::endofstage();
}

bool level3::playerusesitem(levelplayer* who, item* what, sprite* onwhat)
{
	return false;
}
