// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#ifndef _LEVEL3_H
#define _LEVEL3_H

#include <level.h>
#include <camera.h>
#include <levelplayer.h>
#include <item.h>
#include <explosive.h>
#include <swag.h>
#include <door.h>

/// The level3 stage.
class level3 : public level
{
public:
	/// The level3 constructor
	/// \param first_bg First of two HW backgrounds used by this stage.
	level3(int first_bg);
	virtual ~level3();		///< Mansion destructor.
	void compute(bool lowtime);

	virtual bool playerusesitem(levelplayer* who, item* what, sprite* onwhat);
	virtual level::state endofstage();
	
	static const char* description;

private:
#include "level3_lvl_decl.h"

};

#endif
