// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include <SDL.h>
#include "SDLMappy.h"

// shared with enjin
#include <scriptable_tokens.h>
#include <sprite_directions.h>

enum types
{
	t_levelplayer, t_guard, t_swag, t_item, t_explosive, t_sprite, t_camera, t_door, t_scriptable, t_finish, t_undefined
};

#define INIT_CAM_ANGLE m_init[0]
#define INIT_SPRITE_COLLISION m_init[0]
#define INIT_DOOR_OPENPOSX m_init[0]
#define INIT_SWAG_SCORE m_init[0]
#define INIT_FINISH_ENDPOSX m_init[0]
#define INIT_DOOR_OPENPOSY m_init[1]
#define INIT_SPRITE_MAPCOLLISION m_init[1]
#define INIT_FINISH_ENDPOSY m_init[1]
#define INIT_GENERIC_INVISIBLE m_init[2]
#define INIT_GENERIC_HAS_LUASCRIPT m_init[3]
#define INIT_GENERIC_ANIMDIR m_init[4]
#define INIT_SPRITE_SHOVABLE m_init[5]

extern const char* direction_name[];

extern char* tgfx[];
extern SDL_Surface* font;
extern SDL_Surface* typegfx[t_finish];
extern SDL_Surface* marker;

#define MAX_DATASIZE 128
#define MAX_OBJECTS 128
#define OBJECT_SIZE 16	// X/Y size in pixels
#define FONT_WIDTH 8
#define FONT_HEIGHT 16
#define MAX_INITSIZE 16
#define MAX_IDENTIFIER 20
#define MAX_DESCRIPTION 40
#define MAX_SPRITENAME 20

#define BOTTOM_AREA	200 // size of area below map
#define RIGHT_AREA 250 // size of area right of map

struct object
{
	types m_type;
	int m_xpos;
	int m_ypos;
	int m_datasize;
	int m_data[MAX_DATASIZE];
	int m_init[MAX_INITSIZE];
	char m_identifier[MAX_IDENTIFIER];
	char m_description[MAX_DESCRIPTION];
	char m_spritename[MAX_SPRITENAME];
};

int* gettoken(int* script, int size, int token);
void drawline(SDL_Surface* scr, int x1, int y1, int x2, int y2, bool arrow=true);
void drawtext(SDL_Surface* scr, int x, int y, char* fmt, ...);
void addtoscript(object* obj, int selectedtoken, script token, int par0=0, int par1=0, int par2=0, int par3=0, int par4=0);
void redraw(SDL_Surface* scr, SDLMappy* map, object* objs, int objnum, int objsel, int scriptsel, bool locktogrid,bool enteri, bool enterd, bool enters);
void newobject(types t, object* objs, int& objnum, int x, int y);
int getnumparams(int token);
char* escapequotes(char* x);
char* stripbrackets(char* x);
