// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include <levelplayer.h>

levelplayer::levelplayer(level* parent, const spritedata* gfx, int xpos, int ypos)
: player(parent, gfx, xpos, ypos)
{
	m_numitems=0;
	m_parent=parent;

	m_canpassfinishline=false;
	m_finishlinepassed=false;

	enablemapcollision(true);
	parent->addplayer(this);
}

levelplayer::~levelplayer()
{
	m_parent->removeplayer(this);
}

//#define DEBUG_INVENTORY

void levelplayer::addtoinventory(item* what)
{
	ASSERT(m_numitems<LP_INVENTORY_SIZE-1, "inventory full");
#ifdef DEBUG_INVENTORY
	uprintf("adding %s to inv\n", what->getdescription());
#endif
	m_inventory[m_numitems++]=what;
}

void levelplayer::removefrominventory(item* what)
{
	for(int i=0; i<m_numitems; i++)
	{
		if(m_inventory[i]==what)
		{
			m_numitems--;
			for(; i<m_numitems;i++)
				m_inventory[i]=m_inventory[i+1];
			return;
		}
	}
}
