// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include "tutorial/tutorial.h"
#include "mansion/mansion.h"
#include "level1/level1.h"
#include "level2/level2.h"
#include "level3/level3.h"

#include <guard.h>
#include <vbl.h>
#include <misc.h>
#include <debriefing.h>
#include <menu.h>
#include <hardware.h>
#include <input.h>

extern backdropdata debrief_backdrop;

extern const spritedata frame_sprite;
extern const fontdata console_font;
extern const palettedata msgbox_palette;

//#define PROFILE_GAMELOOP

#ifdef PROFILE_GAMELOOP
TOOL_PROFILER_INIT;
#endif

int main()
{
	//int a;
	//uprintf("%d %d -> %d %d\n",52,3, bios_generic(6, 52, 3, 0, 0, &a), a);
	//uprintf("sizes: sprite %d level %d guard %d debriefing %d\n", sizeof(sprite), sizeof(level), sizeof(guard), sizeof(debriefing));

	hw::init();
	input::init();

	while (1)	 // exiting/restarting the whole program works in VBA, but not on the real thing...
	{
		widget::setcharacters(&console_font);
		widget::setpalette(&msgbox_palette);

		const char* mitems[]={"Tutorial","Mansion",level1::description,level2::description,level3::description};
		level* s=0;
		switch(menu::getselection(1, &frame_sprite, &debrief_backdrop, "Seier", mitems, 5))
		{
		case 0:
			s=new tutorial(1);		// tutorial stage using BGs 1 and 2
			break;
		case 1:
			s=new mansion(1);
			break;
		case 2:
			s=new level1(1);
			break;
		case 3:
			s=new level2(1);
			break;
		case 4:
			s=new level3(1);
			break;
		default:
			ASSERT(0, "should never be reached");
		}
		
		while (1)
		{
			VBL_NEXT_FRAME;
			
#ifdef PROFILE_GAMELOOP
			TOOL_PROFILER_START;
#endif
			s->compute(false);
#ifdef PROFILE_GAMELOOP
			TOOL_PROFILER_END;
#endif

			if (s->endofstage())
			{
				int sc,sm,ss,ssec;
				sc=s->getscore();
				ssec=s->getsecrets();
				sm=s->getclockminutes();
				ss=s->getclockseconds();
				switch (s->endofstage())
				{
				case level::c_lost:
				case level::c_draw:
					s->sfxlost();
					delete s;
					new debriefing(1, &frame_sprite, &debrief_backdrop, "Mission Failed", sc, true, ssec, sm, ss);

					break;
				case level::c_won:
					s->sfxwon();
					delete s;
					new debriefing(1, &frame_sprite, &debrief_backdrop, "Mission Accomplished", sc, true, ssec, sm, ss);

					break;
				case level::c_abort:
					delete s;
					break; // ignore
				default:
					ASSERT(0, "should never be reached");
				}
				break;
			}

		};
	}
}
