// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#ifndef _MANSION_H
#define _MANSION_H

#include "level.h"
#include "camera.h"
#include "levelplayer.h"
#include "item.h"
#include "explosive.h"
#include "swag.h"
#include "door.h"

/// The mansion stage.
class mansion : public level
{
public:
	/// The mansion constructor
	/// \param first_bg First of two HW backgrounds used by this stage.
	mansion(int first_bg);
	virtual ~mansion();		///< Mansion destructor.
	void compute(bool lowtime);

	virtual bool playerusesitem(levelplayer* who, item* what, sprite* onwhat);
	virtual level::state endofstage();

private:
#include "mansion_lvl_decl.h"

	bool m_safeblown;	///< Has the safe been opened yet?
	bool m_secretrevealed;	///< Has the secret area been found yet?
};

#endif
