// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include <player.h>
#include <stage.h>
#include <input.h>
#include <vbl.h>

player::player(stage* parent, const spritedata* gfx, int xpos, int ypos)
: sprite(parent, gfx, xpos, ypos)
{
	setadjust(m_xsize/2);			// autoadjust width when running against walls
	setsightable(true);		// guards check whether they can see this sprite
	setaudible(true);
	setradarcolor(S_RADAR_PLAYER);
	setanimtype(sprite::a_motion);
	enablespritecollision(true);
	setblockssight(true);

	m_freeze=false;
	m_speed=2*VBL_FRAMESKIP;

	setdescription("This is you.");
}

void player::compute(bool lowtime)
{
	if(!input::action()) m_ap=false;

	if (!m_freeze)
	{
		if (input::down()) {
			setanimdirection(sprite::d_down);
			setypos(getypos()+m_speed);
		}
		if (input::left()) {
			setanimdirection(sprite::d_left);
			setxpos(getxpos()-m_speed);
		}
		if (input::up()) {
			setanimdirection(sprite::d_up);
			setypos(getypos()-m_speed);
		}
		if (input::right()) {
			setanimdirection(sprite::d_right);
			setxpos(getxpos()+m_speed);
		}
		if (input::action() && !m_ap) {
			m_ap=true;
			m_parent->action(this,faces());
		}
	}
	sprite::compute(lowtime);
}

