// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include <stage.h>
#include <vbl.h>
#include <misc.h>

//#define DEBUG_COLLISION

bool stage::checkcollide(int collmap, int left, int right, int top, int bottom)
{
	int i;
	u8 block;

	// Clip regions off the map edge.
	if(left<0) left=0;
	if(right<0) right=0;
	if(top<0) top=0;
	if(bottom<0) bottom=0;
	if(left>m_xsize-1) left=m_xsize-1;
	if(right>m_xsize-1) right=m_xsize-1;
	if(top>m_ysize-1) top=m_ysize-1;
	if(bottom>m_ysize-1) bottom=m_ysize-1;

#ifdef DEBUG_COLLISION
	uprintf("tl %d %d %d is %d\n", top, left,m_xsize, XYTOMAP(left, top, m_xsize));
#endif
	for(i=left;i<=right;i++)
	{
		block=MAPDATA[collmap][XYTOMAP(i, top, m_xsize)];
		if(!(block&UNOPT_WALKABLE_MASK))	// walkable block
		{
			if(((bool)(block&UNOPT_BLOCK_MASK)) ^ m_mapinvert[collmap]) return true;
		}
		block=MAPDATA[collmap][XYTOMAP(i, bottom, m_xsize)];
		if(!(block&UNOPT_WALKABLE_MASK))	// walkable block
		{
			if(((bool)(block&UNOPT_BLOCK_MASK)) ^ m_mapinvert[collmap]) return true;
		}
	}
	for(i=top;i<=bottom;i++)
	{
		block=MAPDATA[collmap][XYTOMAP(left, i, m_xsize)];
		if(!(block&UNOPT_WALKABLE_MASK)) // walkable block
		{
			if(((bool)(block&UNOPT_BLOCK_MASK)) ^ m_mapinvert[collmap]) return true;
		}
		block=MAPDATA[collmap][XYTOMAP(right, i, m_xsize)];
		if(!(block&UNOPT_WALKABLE_MASK)) // walkable block
		{
			if((bool)((block&UNOPT_BLOCK_MASK)) ^ m_mapinvert[collmap]) return true;
		}
	}
	return false;
}


