// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include <swag.h>
#include <stage.h>

swag::swag(level* parent, const spritedata* gfx, int xpos, int ypos)
: sprite(parent, gfx, xpos, ypos)
{
	m_parent=parent;
	m_score=0;
	m_snatched=false;
	m_autopickup=true;
	enablespritecollision(true);

	setradarcolor(S_RADAR_SWAG);
	setdescription("A piece of swag.");
}

void swag::action(sprite* actor)
{
	if(isvisible())
	{
		m_parent->modifyscore(m_score);
		m_snatched=true;
		hide();
	}
}

void swag::push(sprite* pusher)
{
	if(m_autopickup && m_parent->isplayer(pusher))
		action(pusher);
	else
		sprite::push(pusher);
}
