// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include <widget.h>

#include "template.h"

const char* template::description="template";

#include "template_data.c"

extern const palettedata sprite_palette;
#include "template_lvl_gfx.h"

extern const spritedata frame_sprite;
extern const fontdata console_font;
extern const palettedata msgbox_palette;

template::template(int first_bg)
: level(first_bg, &template_map)
{
	setdefaultcollidemap(1);

	//setexcess(0,0,12,0);
	setscrollbordery(60);
	setscrollborderx(110);
	setspritepalette(&sprite_palette);

#include "template_lvl_ctor.h"

	setradar(0,SCREEN_WIDTH-64, SCREEN_HEIGHT-40, 64, 40);
	
	//scrolllock();
	
	widget::setcharacters(&console_font);
	widget::setpalette(&msgbox_palette);

	enableradar(true);
}

template::~template()
{
}

void template::compute(bool lowtime)
{
	level::compute(lowtime);
}

level::state template::endofstage()
{
	if(getplayer()->hascrossedfinishline()) return c_won;
	return level::endofstage();
}

bool template::playerusesitem(levelplayer* who, item* what, sprite* onwhat)
{
	return false;
}
