// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#ifndef _TEMPLATE_H
#define _TEMPLATE_H

#include <level.h>
#include <camera.h>
#include <levelplayer.h>
#include <item.h>
#include <explosive.h>
#include <swag.h>
#include <door.h>

/// The template stage.
class template : public level
{
public:
	/// The template constructor
	/// \param first_bg First of two HW backgrounds used by this stage.
	template(int first_bg);
	virtual ~template();		///< Mansion destructor.
	void compute(bool lowtime);

	virtual bool playerusesitem(levelplayer* who, item* what, sprite* onwhat);
	virtual level::state endofstage();
	
	static const char* description;

private:
#include "template_lvl_decl.h"

};

#endif
