### HAM Master Makefile           ###
### HAM by  Emanuel Schleussinger ###
### http://www.ngine.de           ###

#
# Initial HAM flag, do not change
#
HAM_CFLAGS = -DHAM_HAM 
#
# Set this to the directory in which you installed
# the HAM system
#
HAMDIR = /home/uli/game_dev/gbadev/ham
#
# Set this dir to the one that contains your
# compiler and linker and stuff (gcc.exe)
#
GCCARM = $(HAMDIR)/gcc-arm
#
# Standard .o files needed for all HAM programs
# do not change
#
OFILES     = crt0.o
#
# This reflects the GCC version used. Important for the library paths
# do not forget to set to new value once you upgrade.
#
HAM_PLATFORM = linux
#
# This reflects the toolchain versions used. Important for the library paths
# do not forget to set to new value once you upgrade.
#
HAM_VERSION_BINUTILS =2.13.2.1
HAM_VERSION_GCC      =3.2.2
HAM_VERSION_INSIGHT  =5.3
HAM_VERSION_NEWLIB   =1.11.0

#
# This selects the type of libraries you want to link. Use 
# - thumb (thumb only library)
# - interwork (arm thumb interworking capable library)
HAM_LIBGCC_STYLE = thumb/normal

#
# make Multiboot the standard, comment out
# normal Cart booting
#
HAM_CFLAGS += -DHAM_MULTIBOOT 
#
# Enable MBV2Lib support
#
HAM_CFLAGS += -DHAM_ENABLE_MBV2LIB 
#
# Enable debugger support
#
# HAM_CFLAGS += -DHAM_DEBUGGER 
#
# Enable GDB symbol support, optional
ifeq ($(MAKECMDGOALS),gdb)
HAM_CFLAGS += -g  
endif
# Enable libHAM support
#
HAM_CFLAGS += -DHAM_WITH_LIBHAM 
#
# Emulator of choice
#
HAM_EMUPATH = 
#
# These options are for setting up the compiler
# You should usually not need to change them.
# Unless you want to tinker with the compiler
# options. 
#

PREFIX      = bin
EXEC_PREFIX = arm-thumb-elf-

ifeq ($(HAM_PLATFORM),win32)
EXEC_POSTFIX = .exe  
else
EXEC_POSTFIX = 
endif

INCDIR      = -I $(HAMDIR)/include -I $(HAMDIR)/system 
LIBDIR      = -L $(GCCARM)/arm-thumb-elf/lib/$(HAM_LIBGCC_STYLE) -L $(GCCARM)/lib -L $(GCCARM)/lib/gcc-lib/arm-thumb-elf/$(HAM_VERSION_GCC)/$(HAM_LIBGCC_STYLE)
CFLAGS      = $(INCDIR) -c $(HAM_CFLAGS) -mthumb-interwork -Wall
ASFLAGS     = -mthumb-interwork 
LDFLAGS     = $(LIBDIR) --script $(HAMDIR)/system/lnkscript 
PATH       +=; $(GCCARM) 
CC          = $(EXEC_PREFIX)gcc$(EXEC_POSTFIX) 
CXX         = $(EXEC_PREFIX)g++$(EXEC_POSTFIX) 
AS          = $(EXEC_PREFIX)as$(EXEC_POSTFIX)
LD          = $(EXEC_PREFIX)ld$(EXEC_POSTFIX) 
OBJCOPY     = $(EXEC_PREFIX)objcopy$(EXEC_POSTFIX) 
EXT         = gba 
ifeq ($(HAM_PLATFORM),win32)
SHELL       = $(HAMDIR)/tools/$(HAM_PLATFORM)/sh$(EXEC_POSTFIX) 
endif
PATH       := $(GCCARM)/$(PREFIX):$(PATH)
GDB	= $(EXEC_PREFIX)gdb
