// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include "tutorial.h"
#include <messagebox.h>
#include <vbl.h>

extern "C" {
#include "vba.h"
}

#include "tutorial_data.c"

extern const palettedata sprite_palette;

#include "tutorial_lvl_gfx.h"

extern const spritedata frame_sprite;
extern const fontdata console_font;
extern const u16 msgbox_Palette[];
extern const portraitdata portrait_portrait;

tutorial::tutorial(int first_bg)
: level(first_bg, &tutorial_map)
{
	setdefaultcollidemap(1);
	setexcess(0,0,96-58,0);
	setscrollbordery(60);
	setscrollborderx(110);
	//s->setmapinversion(0,true);

	setspritepalette(&sprite_palette);

#include "tutorial_lvl_ctor.h"

	faris->setbounding(sprite::b_left,1);	// left edge of bounding box
	faris->setbounding(sprite::b_right,1);	// right edge of bounding box

	scrolllock(faris);			// lock map to faris
	
	guard1->setbounding(sprite::b_left,1);
	guard1->setbounding(sprite::b_right,1);

	guard2->setbounding(sprite::b_left,1);
	guard2->setbounding(sprite::b_right,1);

	book1->setradarcolor(S_RADAR_OFF);

	book2->setbounding(sprite::b_left, 6);

	setradar(0,SCREEN_WIDTH-64, SCREEN_HEIGHT-40, 64, 40);
	
	hint1=hint2=hint3=false;

	enableradar(true);
}

tutorial::~tutorial()
{
}

void tutorial::compute(bool lowtime)
{
	if(!hint1)
	{
		enableradar(false);
		new messagebox(true, 0, "Welcome to the tutorial level. Your mission is to go to the reading tables and snatch the red book. "
					   "Make sure you stay out of sight of the other patrons.", &frame_sprite,
					   &portrait_portrait, SCREEN_WIDTH/8, 8, 0, SCREEN_HEIGHT-8*8, 1);
		enableradar(true);
		hint1=true;
	}

	if(!hint2 && m_xpos>150 && m_ypos>75)
	{
		enableradar(false);
		addhighlightsprite(book2);
		new messagebox(true, 0, "To pick up the book pose yourself in front of it and press the A button. Don't forget to check "
					   "that the air is clean, though.",
                       &frame_sprite, &portrait_portrait, SCREEN_WIDTH/8, 8, 0, SCREEN_HEIGHT-8*8, 1);
		hidehighlights();
		enableradar(true);
		hint2=true;
	}
	
	if(!hint3 && book2->issnatched())
	{
		enableradar(false);
		new messagebox(true, 0, "Great work! Now get out as quickly as possible. Remember not to be seen by anyone!",
                       &frame_sprite, &portrait_portrait, SCREEN_WIDTH/8, 8, 0, SCREEN_HEIGHT-8*8, 1);
		hint3=true;
		enableradar(true);
	}

	level::compute(lowtime);

}

level::state tutorial::endofstage()
{
	level::state s;
	if((s=level::endofstage())) return s;
	
	if (book2->issnatched() && faris->getxpos()<=0 && faris->getypos()<=5*16 && faris->getypos()>=4*16)
		return c_won;

	return c_undefined;
}
