// (C) 2003 Ulrich Hecht <uli@emulinks.de>.
// Distributed under the terms of the GNU Public License v2.

#include <vbl.h>

#include <mygba.h>

//#define DEBUG_MASTERHANDLER

void vbl::masterhandler()
{
	static int skip=VBL_FRAMESKIP;
	m_instance->m_framecount++;
	skip--;
	if(skip) return;
	skip=VBL_FRAMESKIP;
	m_instance->m_newframe=true;
	if(m_instance->m_vblsuspended) return;
	
	for(int i=0;i<m_instance->m_handlernum;i++)
	{
#ifdef DEBUG_MASTERHANDLER
		uprintf("execing handler %x\n", m_instance->m_handlerlist[i]);
#endif
		m_instance->m_handlerlist[i]->vbl_handler();
	}
}

vbl* vbl::m_instance=0;

vbl* vbl::instance()
{
	static vbl inst;
	m_instance=&inst;
	return &inst;
}

vbl::vbl()
{
	m_handlernum=0;
	m_vblsuspended=false;
	m_interruptenabled=false;
	m_framecount=0;
	m_newframe=false;
}

//#define DEBUG_VBL

void vbl::addhandler(object* obj)
{
	ASSERT(m_handlernum<VBL_MAX_HANDLERS, "max. number of interrupt handlers exceeded");
	m_vblsuspended=true;
	m_handlerlist[m_handlernum++]=obj;
	m_vblsuspended=false;
	if(!m_interruptenabled)
	{
		ham_StartIntHandler(INT_TYPE_VBL,(void*)masterhandler);
		m_interruptenabled=true;
	}
#ifdef DEBUG_VBL
	uprintf("add mhnum %d at %x inten %d\n", m_handlernum, (int)obj, m_interruptenabled);
#endif
}

void vbl::removehandler(object* obj)
{
	m_vblsuspended=true;
	for(int i=0;i<m_handlernum;i++)
	{
		if(m_handlerlist[i]==obj)
		{
			m_handlernum--;
			for (int j=i;j<m_handlernum;j++)
				m_handlerlist[j]=m_handlerlist[j+1];
			break;
		}
	}
	m_vblsuspended=false;
	if(m_interruptenabled && !m_handlernum)
	{
		ham_StopIntHandler(INT_TYPE_VBL);
		m_interruptenabled=false;
	}
#ifdef DEBUG_VBL
	uprintf("rem mhnum %d at %x inten %d\n",m_handlernum,(int)obj,m_interruptenabled);
#endif
}

